
-- declaring local variables that will be used only inside map-functions.lua
--tileW, tileH, tileset, quads, tileTable

quadInfo = {
  { '.', 0, 0 }, -- floor outside
  { ' ', 120, 180 }, --10,15 -> 120,180 DONE floor inside
  { '#', 12, 132 }, --1,11 -> 12,132 DONE wall
  { '<', 144, 36 }, -- 12,3 -> 144,36 staircase
  { '$', 48, 24 }, -- 4,2 coin money
  { '^', 60,0 }, -- test , 
  { '>', 168,36 }, --corner right side bottom 18/11
  { '+', 132,24 }, -- closed door 11,2 -> 121, 24
  { '/', 180,24}, --open dor 15,2 -> 180,24
  { '@', 0,48 },
  { '!', 12,24 }, --potion on 1,2 => 12,24
  { ')',108,24 },--weapon 9,2 => 108,24
  { 'c',36,48 }, --3,4 -> 
  { 'b',36,48 },
  { 'd',36,48 },
  { '=', 120, 180 },
  { '-', 144, 168 }, --12,14 -> 144,
}

--newMap(12,12,'Alloy_curses_12x12.png',tileString,quadInfo)
--
dungeonlevel = 1



--function loadMap(path)
  --love.filesystem.load(path)() -- attention! extra parenthesis
function loadMap()

  	maps = {'mapstring.lua','mapstring2.lua'}

	math.randomseed( os.time() )
	math.random(); math.random(); math.random()

	testnumber = math.random(2)

	selectedmap = maps[testnumber]

	--if selectedmap = 

	love.filesystem.load(selectedmap)()
	
	maps[testnumber] = nil

	 enemies = nil
	 enemies = {}
	
	 generateEnemy()
  	for i=1,5 do	
		--generateEnemy()
		table.insert(enemies,createEnemy())
	end

	--loadMap(maps)
end

function newMap(tileWidth, tileHeight, tilesetPath, tileString, quadInfo)
  
  tileW = tileWidth
  tileH = tileHeight
  tileset = love.graphics.newImage(tilesetPath)

  map = {}

  map.time = 30-30/100*dungeonlevel

  map.timequotient = map.time
  
  local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
  
  quads = {}
  
  for _,info in ipairs(quadInfo) do
    -- info[1] = the character, info[2] = x, info[3] = y
    quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW, tileH, tilesetW, tilesetH)
  end
  
  tileTable = {}
  
  local width = #(tileString:match("[^\n]+"))

  for x = 1,width,1 do tileTable[x] = {} end

  local rowIndex,columnIndex = 1,1
  for row in tileString:gmatch("[^\n]+") do
    assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    columnIndex = 1
    for character in row:gmatch(".") do
      tileTable[columnIndex][rowIndex] = character


      if tileTable[columnIndex][rowIndex] == ')' and dungeonlevel > 1 then
	      tileTable[columnIndex][rowIndex] = ' '
	end

      -- add random items
	
	if tileTable[columnIndex][rowIndex] == " " and love.math.random(150) == 20 then
		--love.graphics.setColor(255,255,255)
		tileTable[columnIndex][rowIndex] = '$'
	end

	if tileTable[columnIndex][rowIndex] == ' ' and love.math.random(1000) == 10 then

		tileTable[columnIndex][rowIndex] = "!"
	end

	if tileTable[columnIndex][rowIndex] == ' ' and love.math.random(10) == 5 then
		tileTable[columnIndex][rowIndex] = "="
	end

	--if tileTable[columnIndex][rowIndex] == ' ' and love.math.random


	columnIndex = columnIndex + 1
	
	
      --love.graphics.setColor(255,255,255)
      --love.graphics.print(character,100,100)

    end
    rowIndex=rowIndex+1
  end

end

function checkEnemy(columnIndex,rowIndex)
	if tileTable[columnIndex][rowIndex] ~= ' ' then
		return true
	end

	return false
end

function checkitems(dx,dy)

	x= 0

	--local addmessagetest = true
	--addmessage = true

	--[[if tileTable[playertilex+dx][playertiley+dy] == '$' then
		playertest.money = playertest.money + 1
		output.addMessage("You picked up a coin!")
		tileTable[playertilex][playertiley] = ' '
	end]]

	if tileTable[playertilex+dx][playertiley+dy] == "^" then
		playertest.hp = 0
	end

	if tileTable[playertilex+dx][playertiley+dy] == '$' then
		

		--[[if addmessagetest == true then
			output.addMessage("Press , to pick up a coin!")
		end]]

		--[[while addmessagetest == true do
			output.addMessage("Press , to pick up a coin!")
			addmessagetest = false
		end]]

		output.addMessage("On the floor lies a gold coin.")

		
		--tileTable[playertilex+dx][playertiley+dy] ~= '$'
	end

	if tileTable[playertilex+dx][playertiley+dy] == "=" then
		randomtilex = math.random(1,50)
		randomtiley = math.random(1,30)
	
		if tileTable[randomtilex][randomtiley] ~= ' ' then
			randomtilex = math.random(1,50)
			randomtiley = math.random(1,30)
		else 	
			tileTable[playertilex][playertiley] = '-'
			output.addMessage("You walked into a portal!")
			playertilex = randomtilex
			playertiley = randomtiley

			tileTable[playertilex][playertiley] = '-'
		end

	end



	if tileTable[playertilex+dx][playertiley+dy] == "!" then
		output.addMessage("You see here a potion!")
	end


	if tileTable[playertilex+dx][playertiley+dy] == '+' then
		tileTable[playertilex+dx][playertiley+dy] = '/'
	end

	if tileTable[playertilex+dx][playertiley+dy] == ')' then
		--tileTable[playertilex+dx][playertiley+dy] = ' '
		output.addMessage("Press , to pick up the katana!")
	end

	addmessagetest = false
	
end

function removeitem()

	--if tileTable[playertilex][playertiley] ~= ' ' then


		if tileTable[playertilex][playertiley] == '$' then
			tileTable[playertilex][playertiley] = ' '
		end

		if tileTable[playertilex][playertiley] == ')' then
			tileTable[playertilex][playertiley] = ' '
		end

		if tileTable[playertilex][playertiley] == '!' then
			tileTable[playertilex][playertiley] = ' '
		end


	--end


end

function isitfloor()

	if tileTable[playertilex][playertiley] == ' ' then
		return false
	end

	return true

end

function changemap()

	if tileTable[playertilex][playertiley] == '<' then

		playertilex = 25
		playertiley = 15
		playertest.dungeonlevel = playertest.dungeonlevel + 1
		dungeonlevel = dungeonlevel + 1
		loadMap()

		return dungeonlevel
	end
end
		

function drawMap()
	--love.graphics.setColor(255,255,255)
	-- transparency variable = >
	t = (map.time/map.timequotient)*255
	love.graphics.setColor(255,255,255,t)
	--a= math.random(255)
	--b=math.random(255)
	--c=math.random(255)
  	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0

		if tileTable[columnIndex][rowIndex] == '$' then
			love.graphics.setColor(218,165,32,t)
		end
		if tileTable[columnIndex][rowIndex] == "^" then
			love.graphics.setColor(48,48,211,t)
		end

		if tileTable[columnIndex][rowIndex] == '-' then
			love.graphics.setColor(80,192,238)
		end

      		love.graphics.draw(tileset, quads[ char ] , x, y)
		love.graphics.setColor(255,255,255,t)

      		--[[if tileTable[columnIndex][rowIndex] == '.' then
	     	 	love.graphics.print("FUCK YOU",x,y)
		end]] -- TEST CONCEPT WORKS

		--[[if tileTable[columnIndex][rowIndex] == "." and love.math.random(10) == 10 then
			love.graphics.setColor(255,0,0)
			love.graphics.rectangle("fill",12*(columnIndex-1)+200,12*(rowIndex-1),12,12)
		end]]
   	 end
  	end
end

--[[function mapcheck()
	--local x = 1
	--local y = 1
	--
	test:coordinate(x,y)
	
	for columnIndex,column in ipairs(tileTable) do
		for rowIndex,char in ipairs(column) do

			if tileTable[self.x][self.y] == '#' then
				return false
			end
			return true
		end
	end

end]]


--[[function mapcheck(x,y)

	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		--local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0
      		--love.graphics.draw(tileset, quads[ char ] , x, y)
		--

			
			
		
			if tileTable[0][0] == '#' then
				return false
			else 
				return true
			end

      		--if tileTable[columnIndex][rowIndex] == '.' then
	     	 	love.graphics.print("FUCK YOU",x,y)
		end -- TEST CONCEPT WORKS
   	 	end
  	end



end]]

function playercheck(dx,dy)

	--TILETABLE[Y][X] FK ME

	--local dx,dy = 0,0
	--playertile = 791

	
	--love.graphics.setColor(0,255,0)
	--love.graphics.print("$",(playertiley)*12,(playertilex)*12+200)

	if tileTable[playertilex][playertiley-1] == '#' then --UP
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.rectangle("fill",(playertilex-1)*12+200,(playertiley-2)*12,12,12)
	end
	if tileTable[playertilex][playertiley+1] == '#' then --DOWN
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-1)*12+200,playertiley*12,12,12)
	end

	if tileTable[playertilex+1][playertiley] == '#' then --RIGHT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",playertilex*12+200,12*(playertiley-1),12,12)
	end

	if tileTable[playertilex-1][playertiley] == '#' then --LEFT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-2)*12+200,(playertiley-1)*12,12,12)
	end

	if tileTable[playertilex+dx][playertiley+dy] == '#' then
		return false
	end

	for i,v in ipairs(enemies) do
		if playertilex+dx == v.x and playertiley + dy == v.y then
			--playerattackenemy()
			--
				--playertest = {}
				--
			math.randomseed( os.time() )
			math.random(); math.random(); math.random()

			local critcheckplayer = math.random(100)
			--output.addMessage(critcheckplayer) for debugging

			critplayer = false

			playerdamage = playertest.basedmg

			if critcheckplayer < playertest.critchance + 1 then
				--playertest.basedmg = 2 * playertest.basedmg
				playerdamage = playerdamage * 2
				critplayer = true
			end
	
			v.hp = v.hp - playerdamage

			if critplayer == true then
				attackstyle = "critted"
			else
				attackstyle = "attacked"
			end

			--output.addMessage("You "..playertest.name.." "..attackstyle.." for: "..playertest.basedmg.." damage")
			
			--love.graphics.setColor(0,255,0)

			output.addMessage(playertest.name.." "..attackstyle.." the "..enemy.name.." for: "..playerdamage.." damage")

			if v.hp <= v.minhp then

				output.addMessage("The "..enemy.name.." died!")

				table.remove(enemies,i)

			end


			--[[enemy.basedmg = 20
			enemy.critchance = 90
			enemy.hp = 60
			enemy.minhp = 0]]

			if v.hp > v.minhp then

				enemydamage = v.basedmg


				local critcheckenemy = math.random(100)

				critenemy = false

				if critcheckenemy < v.critchance + 1 then
					enemydmg = enemydmg * 2
					critenemy = true
				end

				--playertest.hp = playertest.hp - v.basedmg

				playertest.hp = playertest.hp - enemydamage


				--[[if playertest.basedmg > 20 then
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." critted for: "..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				else	
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." monster attacked you for:"..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				end]]

				if critenemy == true then
					attackstyle = "critted"
				else
					attackstyle = "attacked"
				end

				--for debugging  monster dmg etc remove later on just  display health loss and how much dmg u do

			
				--love.graphics.setColor(255,0,0)

				output.addMessage("The "..v.name.." "..attackstyle.." you for: "..enemydamage.." damage")

			end


		return false

		end
	end

	return true
			

	--if tileTable[playertilex+dx][playertiley+dy] == '#'  then
		--return false
	
	--[[if tileTable[playertilex+dy][playertiley+dy] == '+' then
		return false
	end

	return true]]

	--return true

end

function doorcheck(dx,dy)

	doorbreak = 0

	--[[if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) == 3 then
		output.addMessage("You opened a door!")
		return true
	elseif tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) ~= 3 then
		output.addMessage("The door is locked. Kick it in!")
		return false
	end

	if tileTable[playertilex + dx][playertiley + dy] ~= '+' then
		return true
	end]]

	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(5) == 3 then
		output.addMessage("You opened a door!")
		return true
	end
	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(5) ~= 3 then
		doorbreak = 0
		if doorbreak == 0 then
			output.addMessage("The door is locked. Kick it in!")
			doorbreak = doorbreak + 1
		elseif doorbreak ~= 0 then
			output.addMessage("KABOOM!")
		end
		return false
	end
	
	if tileTable[playertilex+dx][playertiley+dy] ~= '+' then
		return true

	end


end

function playertileon()

	if tileTable[playertilex][playertiley] == ")" then
		output.addMessage("You picked up a katana")
	end

	if tileTable[playertilex][playertiley] == "$" then
		output.addMessage("You picked up a coin!")
	end

	if tileTable[playertilex][playertiley] == "!" then
		output.addMessage("You picked up a potion!")
	end


end

--[[function additems()

	if tileTable[columnIndex][rowIndex] == "." and love.math.random(10) == 10 then
		tileTable[columnIndex][rowIndex] = "*"
	end

end]]

